"use strict"
// базовый общий для всех
XHEBaseObject = require("../../xhe_base.js")

/////////////////////////////////////////// Plgn_oracledb ////////////////////////////////////////
class XHEORACLEDB extends XHEBaseObject
{
///////////////////////////////// SERVICE FUNCTIONS ////////////////////////////////////////////////
    // server initialization
    constructor(server, password = "") {
	    super(server, password, "Plgn_oracledb")
    }
/////////////////////////////////////////////////////////////////////////////////////////////////////

    // Подключиться к базе данных (oracle)
    connect(alias, connection_string) {
        const params = ["alias", alias, "connection_string", connection_string]
        return this.call_get("connect", params)
    }

    // Отключиться от базы данных (oracle)
    disconnect(alias) {
        const params = ["alias", alias]
        this.call_get("disconnect", params)
    }

    // выполнить запрос query (oracle)
    execute_query(alias, query) {
        const params = ["alias", alias, "query", query]
        return this.call_get("execute_query", params)
    }

    // выполнить запрос scalar (oracle)
    execute_scalar(alias, query) {
        const params = ["alias", alias, "query", query]
        return this.call_get("execute_scalar", params)
    }

    // выполнить запрос non query (oracle)
    execute_non_query(alias, query) {
        const params = ["alias", alias, "query", query]
        return this.call_get("execute_non_query", params)
    }

    // вызов хранимои процедуры (oracle)
    call_stored_procedure(alias, procedure_name, parameters) {
        const params = ["alias", alias, "procedure_name", procedure_name, "parameters", parameters]
        return this.call_get("call_stored_procedure", params)
    }
}
module.exports = XHEORACLEDB
