<?php
/////////////////////////////////////////// Plgn_oracledb //////////////////////////////////////
class XHEORACLEDB extends XHEBaseObject
{
//////////////////////////// SERVICE FUNCTIONS /////////////////////////////////////////////////////
    // server initialization
    private string $inner_number;

    function __construct(string $server, string $password="")
	{
		$this->server = $server;
		$this->password = $password;
		$this->prefix = "Plgn_oracledb";
	}
/////////////////////////////////////////////////////////////////////////////////////////////////////    
    
    // Подключиться к базе данных (oracle)
    function connect(string $alias, string $connection_string): bool
    {
        $params = array( "alias" => $alias, "connection_string" => $connection_string );
        return $this->call_get(__FUNCTION__, $params);
    }

    // Отключиться от базы данных (oracle)
    function disconnect(string $alias): void
    {
        $params = array( "alias" => $alias );
        $this->call_get(__FUNCTION__, $params);
    }

    // выполнить запрос query (oracle)
    function execute_query(string $alias, string $query): string
    {
        $params = array( "alias" => $alias, "query" => $query );
        return $this->call_get(__FUNCTION__, $params);
    }

    // выполнить запрос scalar (oracle)
    function execute_scalar(string $alias, string $query): string
    {
        $params = array( "alias" => $alias, "query" => $query );
        return $this->call_get(__FUNCTION__, $params);
    }

    // выполнить запрос non query (oracle)
    function execute_non_query(string $alias, string $query): int
    {
        $params = array( "alias" => $alias, "query" => $query );
        return $this->call_get(__FUNCTION__, $params);
    }

    // вызов хранимои процедуры (oracle)
    function call_stored_procedure(string $alias, string $procedure_name, string $parameters): bool
    {
        $params = array( "alias" => $alias, "procedure_name" => $procedure_name, "parameters" => $parameters );
        return $this->call_get(__FUNCTION__, $params);
    }
};

?>
