from Objects.xhe_base import *


# Plgn_oracledb
class XHEORACLEDB(XHEBaseObject):
    # server initialization
    def __init__(self, server: str, password: str=""):
        self.server = server
        self.password = password
        self.prefix = "Plgn_oracledb"


    # Подключиться к базе данных (oracle)
    def connect(self, alias: str, connection_string: str) -> bool:
        params = {"alias": alias, "connection_string": connection_string}
        return self.call_get("connect", params)


    # Отключиться от базы данных (oracle)
    def disconnect(self, alias: str) -> None:
        params = {"alias": alias}
        self.call_get("disconnect", params)


    # выполнить запрос query (oracle)
    def execute_query(self, alias: str, query: str) -> str:
        params = {"alias": alias, "query": query}
        return self.call_get("execute_query", params)


    # выполнить запрос scalar (oracle)
    def execute_scalar(self, alias: str, query: str) -> str:
        params = {"alias": alias, "query": query}
        return self.call_get("execute_scalar", params)


    # выполнить запрос non query (oracle)
    def execute_non_query(self, alias: str, query: str) -> int:
        params = {"alias": alias, "query": query}
        return self.call_get("execute_non_query", params)


    # вызов хранимои процедуры (oracle)
    def call_stored_procedure(self, alias: str, procedure_name: str, parameters: str) -> bool:
        params = {"alias": alias, "procedure_name": procedure_name, "parameters": parameters}
        return self.call_get("call_stored_procedure", params)

